﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using System.Collections;

namespace WindowsFormsApplication1
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
        }

        void IdentifyAssemblyFullName(string input)
        {
            if (string.IsNullOrEmpty(input))
                return;

            if (!File.Exists(input))
            {
                txtLog.Text = "File not exists.";
                return;
            }

            string ext = Path.GetExtension(input);
            if (string.Compare(".exe", ext, true) == 0 || string.Compare(".dll", ext, true) == 0)
            {
                try
                {
                    Assembly a = Assembly.LoadFile(input);
                    txtLog.Text = a.FullName;
                }
                catch (Exception ex)
                {
                    txtLog.Text = ex.ToString();
                }
            }
            else
            {
                txtLog.Text = "Support only .exe and .dll.";
            }
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            IdentifyAssemblyFullName(txtPath.Text.Trim());
        }

        private void btnGetPath_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = txtPath.Text.Trim();
            if (DialogResult.OK == openFileDialog1.ShowDialog())
            {
                txtPath.Text = openFileDialog1.FileName;
            }

        }

        private void txtPath_DragDrop(object sender, DragEventArgs e)
        {
            var files = e.Data.GetData(DataFormats.FileDrop) as Array;
            IEnumerator ie = files.GetEnumerator();
            ie.MoveNext();
            txtPath.Text = ie.Current.ToString();
        }

        private void txtPath_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void txtPath_TextChanged(object sender, EventArgs e)
        {
            IdentifyAssemblyFullName(txtPath.Text.Trim());
        }
    }
}
